#ifndef _MAIN_HPP_
#define _MAIN_HPP_

#include <iomanip>
#include <iostream>
#include <fstream>
#include <sstream>

#include <map>
#include <vector>
#include <queue>

#include <assert.h>
#include <getopt.h>
#include <limits.h>
#include <math.h>
#include <stdlib.h>
#include <unistd.h>

using namespace std;

#define NOT_USE -1

// Inter-Box
#define NORTH 1
#define EAST  2
#define SOUTH 3
#define WEST  4
#define UP    5
#define DOWN  6

struct Point{
	int x;
	int y;
	int z;
};

#include "line.hpp"
#include "box.hpp"
#include "board.hpp"

#define ML 3  // コストの計算（配線長） 
#define BT 3  // コストの計算（曲がり回数） 
#define PL 1  // コストの計算（周辺ノード） 

struct Search{
	int x;
	int y;
	int z;
	int d; // 方向
};

struct Direction{
	// 方向
	bool n;	// 北
	bool s;	// 南
	bool e;	// 東
	bool w;	// 西
	bool u; // 上
	bool d; // 下
	// ひとつ前の方向
	int c_n;
	int c_s;
	int c_e;
	int c_w;
	int c_u;
	int c_d;
};

struct IntraBox{
	int cost;
	Direction d;
};


/*******************************************************/
/** グローバル関数定義 **/
/*******************************************************/

void initialize(char* filename);
void readSolution(char* filename, bool print_option);

#endif /*_MAIN_HPP_*/
